SystemOrganization addCategory: #ConfigurationOfStruppi!

Object subclass: #ConfigurationOfStruppi
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfStruppi'!

!ConfigurationOfStruppi class methodsFor: 'development support' stamp: 'FrancoisStephany 1/4/2012 10:36'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfStruppi class methodsFor: 'private' stamp: 'FrancoisStephany 1/4/2012 10:36'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfStruppi class methodsFor: 'private' stamp: 'FrancoisStephany 1/4/2012 10:36'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfStruppi class methodsFor: 'private' stamp: 'FrancoisStephany 1/4/2012 10:36'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfStruppi class methodsFor: 'metacello tool support' stamp: 'FrancoisStephany 1/4/2012 10:36'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfStruppi class methodsFor: 'loading' stamp: 'FrancoisStephany 1/4/2012 10:36'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfStruppi class methodsFor: 'loading' stamp: 'FrancoisStephany 1/4/2012 10:36'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfStruppi class methodsFor: 'loading' stamp: 'FrancoisStephany 1/4/2012 10:36'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfStruppi class methodsFor: 'accessing' stamp: 'FrancoisStephany 1/4/2012 10:36'!
project

	^self new project! !

!ConfigurationOfStruppi class methodsFor: 'development support' stamp: 'FrancoisStephany 1/4/2012 10:36'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfStruppi methodsFor: 'baselines' stamp: 'FrancoisStephany 1/4/2012 10:44'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		
		spec
			repository: 'http://www.squeaksource.com/TFFiler';
			package: 'TF-Filer'.

		spec project: 'Gofer' with: [
			spec
				className: 'ConfigurationOfGofer';
				versionString: #'stable';
				repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec repository: 'http://ss3.gemstone.com/ss/struppi'.
		spec package: 'Struppi-Core' with: [
				spec requires: #('Gofer' 'TFFiler' ). ].
		spec group: 'default' with: #('Struppi-Core' ). ].
! !

!ConfigurationOfStruppi methodsFor: 'accessing' stamp: 'FrancoisStephany 1/4/2012 10:36'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfStruppi methodsFor: 'symbolic versions' stamp: 'FrancoisStephany 1/4/2012 10:47'!
stable: spec
	<symbolicVersion: #'stable'>
	spec for: #'pharo1.3.x' version: '0.1'.
! !

!ConfigurationOfStruppi methodsFor: 'versions' stamp: 'FrancoisStephany 1/4/2012 10:47'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline')>
	spec for: #common do: [
		spec blessing: #release.
		spec
			package: 'TF-Filer'   with: 'TF-Filer-TonyFleig.18.mcz';
			package: 'Struppi-Core' with: 'Struppi-Core-FrancoisStephany.1'.
	]! !
